%{
open Lang_src
%}

%token EOF EQUAL SEMICOLON LPAREN RPAREN
%token <Big_int.big_int> NUM
%token <Lang_common.binop> BINOP
%token INPUT OUTPUT VAR LBL UNIT NAT BOP IFNZ PAIR FST SND INL INR CASE
%token ROLL FIX APP GEN INST PACK UNPACK NEW READ WRITE REFEQ LET

%start annotated_modul
%type <Lang_common.label list * Lang_src.coq_module> annotated_modul

%%
annotated_modul:
    imports SEMICOLON modul  { ($1, $3) }
;

imports:
    { [] }
  | NUM imports  { $1 :: $2 }
;

modul:
  EOF { [] }
  | NUM BINOP expr SEMICOLON modul  { ($1, $3) :: $5 }
;

expr:
    LPAREN expr RPAREN  { $2 }
  | INPUT  { Einput }
  | OUTPUT expr  { Eoutput $2 }
  | VAR NUM  { Evar $2 }
  | LBL NUM  { Elbl $2 }
  | UNIT  { Eunit }
  | NAT NUM  { Enat $2 }
  | BOP BINOP expr expr  { Ebop ($2, $3, $4) }
  | IFNZ expr expr expr  { Eifnz ($2, $3, $4) }
  | PAIR expr expr  { Epair ($2, $3) }
  | FST expr  { Efst $2 }
  | SND expr  { Esnd $2 }
  | INL expr  { Einl $2 }
  | INR expr  { Einr $2 }
  | CASE expr NUM expr expr  { Ecase ($2, $3, $4, $5) }
  | ROLL expr  { Eroll $2 }
  | FIX NUM NUM expr  { Efix ($2, $3, $4) }
  | APP expr expr  { Eapp ($2, $3) }
  | GEN expr  { Egen $2 }
  | INST expr  { Einst $2 }
  | PACK expr  { Epack $2 }
  | UNPACK NUM expr expr  { Eunpack ($2, $3, $4) }
  | NEW expr  { Enew $2 }
  | READ expr  { Eread $2 }
  | WRITE expr expr  { Ewrite ($2, $3) }
  | REFEQ expr expr  { Erefeq ($2, $3) }
  | LET NUM expr expr  { coq_Elet $2 $3 $4 }
;
